## Users

SeqWare is currently used by a variety of NGS users including the [Lineberger Comprehensive Cancer Center](http://unclineberger.org/) at UNC, at the [Ontario Institute for Cancer Research](http://oicr.on.ca) in Toronto and by our commercial partner [Nimbus Informatics](http://nimbusinformatics.com).

The majority of SeqWare development is currently happening at [OICR](http://oicr.on.ca) and [Nimbus Informatics](http://nimbusinformatics.com).

<a href="http://oicr.on.ca"><img src="http://oicr.on.ca/files/imagecache/logo_size/OICR2logo.png"/></a>

<a href="http://unclineberger.org"><img width="250px" src="http://unclineberger.org/dif/images/unc-lineberger-logo/image"/></a>

##Commercial Partner

Please see Nimbus' website if you are interested in consulting services for SeqWare workflow creation, hosting of SeqWare on Amazon's cloud, or support for local installs of SeqWare.

<a href="http://nimbusinformatics.com"><img width="250px" src="/assets/images/nimbus_clear.png"/></a>

## Contributions

These are the folks that have made SeqWare possible.  Most development activity now centers around SeqWare at Nimbus Informatics and OICR:

* **Brian O'Connor**: Director of Cloud Projects. Started the project in the Nelson lab and moved in 2010 to UNC which was the TCGA center responsible for RNASeq data creation. Brian is currently directing SeqWare and all other cloud-based projects under the software engineering umbrella. You can contact Brian at briandoconnor at gmail dot com.
* **Denis Yuen**: Developer/architect on all things SeqWare at OICR since 2012. Also a cloud / dev-ops developer on projects such as [Bindle](https://github.com/CloudBindle). 
* **Pipeline (Workflow) Development and Evaluation**: Develop workflows (among other useful things) on top of SeqWare at OICR
    * **Morgan Taschuk**: Program leader 
    * **Michael Laszloffy, Peter Ruzanov**: Workflow developers  
* **Production**: Use SeqWare on a day-to-day basis
    * **Tony Debat**: Developer, responsible for migration of data from LIMS and various pieces of site-specific software at OICR 
    * **Xuemei Luo**: Responsible for SeqWare operations

### Alumni

These are folks that have previously worked on SeqWare.

* **Jordan Mendler **: developer/architect. Worked on the project in the Nelson Lab at UCLA. Jordan focused on SeqWare Pipeline.
* **Sara Grimm **: developer/analyst. Worked on the project in the Lineberger Bioinformatics group at UNC. Sara focused on SeqWare Pipeline modules for RNAseq analysis.
* **Jianying Li **: developer/analyst. Worked on the project in the Lineberger Bioinformatics group at UNC. Jianying focused on SeqWare Pipeline modules for QC reporting and statistical analysis on RNAseq data.
* **Matt Soloway**: developer/user. Worked on the project in the Lineberger Bioinformatics group at UNC. Matt focuses on SeqWare MetaDB dataload and also workflows, which links -BOTH- modules for automated distribution of computations on the cluster -AND- results to SeqWare users.
* **Yong Liang**: SeqWare Web Service and Pipeline Developer at OICR.
* **Marc Carlson**: SeqWare Pipeline module developer.
* **Stuart Jefferys**: developer/user. Worked on the project in the Lineberger Bioinformatics group at UNC. Stuart focused on SeqWare Pipeline development.
* **Oleg Boussel, Dmitry Nevaikin, and others with VRP Inc **: VRP created the SeqWare Portal version we have today. Recently wrapped up this consulting work.
* **Joachim Baran**: Contributor for the SeqWare Query Engine at OICR.
